================================================================================
 IBM* APL2* for OS/2* Corrective Service Diskette README.csd file:

 APL2 for OS/2 Entry Edition - Version 1.0
 (C) Copyright IBM Corp. 1994. All Rights Reserved.
 US Government Users Restricted Rights - Use, duplication or disclosure
 restricted by GSA ADP Schedule Contract with IBM Corp.
================================================================================

================================================================================
 APL2 for OS/2 -- Service Level 2  (cumulative)
================================================================================

 You should have 2 diskettes.

 To install:

  1. Insert diskette 1 in your computer and type a:service
     (or b:service if you are installing from drive B).

  2. When you see the "Instructions" window, click on 'Continue'
     (or press 'Enter').

  3. When you see the "Update" window, click on 'OK' (or press Enter).

     Because the service does not update config.sys, you need not
     (and can not) click on the "Update CONFIG.sys" button.

     Unless you are very short on space on the disk where APL2
     is installed, leave the box marked 'Save a backup version'
     checked.  This will allow you to restore the previous level
     of APL2 if you have any problems with the new level.

  4. When prompted by the "insert disk" window, insert the second
     disk.

  5. When you see the "Installation and Maintenance" window indicating
     that APL2 has been successfully updated, click on 'OK' (or press
     enter.

  6. Select 'Exit' from the 'File' pulldown to exit from the
     maintenance program.

 The servicing of APL2 for OS/2 Advanced is complete. You do not need
 to re-start OS/2 for the service to take effect.

 Note:  The APL2ITAL font has been updated in this service level.
        If you would like to use this updated font, you will need
        to un-install and then re-install it.  See the APL2 for
        OS/2 User's Guide for information on un-installing and
        installing fonts.  This font is listed in the font palette
        as "APL2" and the style is "Italic".

================================================================================
 Problems fixed by Service Level 2
================================================================================

 )COPY
   KOB0150  May cause unnecessary WS FULL
   KOB0154  Of APL2/PC workspace loses active WS

 )IN
   KOB0139  More problems
   KOB0218  Unnecessary WS FULL on )IN

 )SAVE
   KOB0129  To nearly full disk can crash or leave file in an unusable state
   KOB0196  Reports sucess when library is full on AFS

 -------------------------------------------------------------------------------

 APL language (primitives)
   KOB0097  More problems with  (Execute Each)
   KOB0114  Wrong result from Residue with complex numbers
   KOB0126  Plus, Minus, or Times of arithmetic progression may fail
   KOB0228  Indexing failure after reduction of 1-element APV

 APL language (system names)
   KOB0116  AI (QuadAI) grossly over-reports CPU time
   KOB0119  Dyadic SVO (QuadSVO) used for query gives 0 as partner ID
   KOB0187  Function name wrong in CR (QuadCR) of operand
   KOB0229  Workspace lost after ES (QuadES) 1 2

 APL language (syntax)
   KOB0144  CHECKWS if type reduction occurs during stranding of general arrays
   KOB0186  SYNTAX ERROR caused by redundant parentheses
   KOB0238  Performance of Indexed Specification

 APL language (display)
   KOB0108  Comment lines not traced
   KOB0185  Format by specification may omit a blank

 -------------------------------------------------------------------------------

 External functions (general)
   KOB0163  Function can return incorrect result
   KOB0188  SYSTEM ERROR with external function as operand to defined operator

 ATR external function
   KOB0045  Fails for empty array
   KOB0073  Corrupts CR (QuadCR) of caller

 FILE external function
   KOB0103  Incorrect return on read of Zero length file
   KOB0197  Ensure proper close on file I/O error

 RTA external function
   KOB0152  Crashes on null character string
   KOB0248  Allow * in one dimension length of pattern

 -------------------------------------------------------------------------------

 AP 124
   KOB0057  Painting problems on VGA

 AP 145
   KOB0100  Needs to send WM_PAINT from AplFontDlg
   KOB0206  Support for Secondary Window Services
   KOB0246  Parameter error in DosOpen call (wrong level of indirection)

 AP 207
   KOB0081  Using incorrect APL characters in on-line help
   KOB0115  Demos wait even if running in automatic mode
   KOB0118  Error in MIX query
   KOB0134  Additional resolution fixes
   KOB0136  Pointer does not support tracking rectangle and centered sizing
   KOB0137  Only has 16 colors defined for default
   KOB0143  Improve command performance
   KOB0160  WINDOW command ignores first 4 parameters
   KOB0164  Window does not close on retract
   KOB0165  LINETYPE command does not set linewidth

 AP 211
   KOB0216  Error 33 writing object in UPDATE mode

 -------------------------------------------------------------------------------

 GRAPHPAK workspace
   KOB0101  Gives error if user closes AP207 window directly

 Session manager
   KOB0110  Cursor disappears
   KOB0166  Dead key in Manugistics Unified layout
   KOB0171  Terminates after object editor saves renamed function
   KOB0178  FeelX (a PM shell replacement) crashes session manager dialogs

 Editors
   KOB0053  Changes to a suspended function not honored
   KOB0130  SYSTEM ERROR in Editor 1 after interrupt Quad prompt
   KOB0149  Incorrect line number after Find (APLEDIT)
   KOB0213  Changes lost after error fixing edited function

 Fonts
   KOB0151  Clean up APL2 Italic

================================================================================
 Problems fixed by the previous service level
 (Corrections are included in these service diskettes.)
================================================================================

 )CHECK
   KOA0486  Erroneous CHECKWS if shared variable is shadowed
   KOB0004  Erroneous CHECKWS after using )OUT and )CLEAR

 )COPY
   KOA0500  Can corrupt the workspace, giving objects the wrong values
   KOA0500  Can cause a later SYSTEM ERROR
   KOB0005  NOT COPIED for a valid object listed explicitly
   KOB0014  SYSTEM ERROR when an object name is listed twice
   KOB0017  NOT COPIED for previously shared variables
   KOB0067  May crash the interpreter.
   KOB0077  Garbage when resume execution after )COPY to resolve VALUE ERROR
   KOB0086  No indication when fails due to WS FULL
   KOB0109  May crash rather than giving WS FULL

 )IN
   KOA0501  Can hang reading a corrupted or incomplete transfer file
   KOB0020  May crash interpreter on workspace full
   KOB0035  Should give NOT COPIED on file from host with P10 name association
   KOB0037  Does not replace a function.
   KOB0091  Following )OUT of same transfer file may loop or hang

 )LOAD
   KOB0046  May crash the interpreter on workspace too large

 )PCOPY
   KOB0006  Reports NOT COPIED for objects previously erased in source workspace
   KOB0015  Can crash on workspace with marginally enough space

 )SAVE
   KOA0500  CHECKWS messages after )COPY.

 )VARS
   KOB0013  May include names outside the specified name range

 -------------------------------------------------------------------------------

 APL language (primitives)
   KOA0487  WS storage lost on reduction by a defined or derived function
   KOB0001  WS storage lost during catenate of a general array
   KOB0002  Bad result on [  ] (First of a progression within brackets)
   KOB0011  Crash after a value error while doing  (Execute Each)
   KOB0059  Bad value from  (Member) if a workspace garbage collection occurs
   KOB0061  INDEX ERROR may be reported when the index is all 0's and 1's
   KOB0062  SYSTEM ERROR possible during dyadic  (Pick)
   KOB0065  Wrong value multiplying a vector of large integers by a power of 2
   KOB0069  WS storage lost on  (Match) if an argument type is reduced
   KOB0090  Wrong result of Residue if the right argument > a million times left

 APL language (system names)
   KOB0012  WS storage lost after 2 TF of a transfer form
   KOB0018  Crash on 2 AT if object's date was bad in a transfer file
   KOB0025  Bad data from external function if SVE issued first
   KOB0032  SYNTAX ERROR using LC within a strand (for example, 4 LC 3 'A')
   KOB0052  WS storage lost after 0 from EA (Branch to zero from QuadEA)
   KOB0066  Display missing for result of EC if assignment is last
   KOB0072  Garbage from monadic NA if the argument contains many names
   KOB0085  DOMAIN ERROR for near-integer real numbers on the left of SVO

 APL language (syntax)
   KOA0503  Names longer than 255 characters treated as very short
   KOB0036  VALUE ERROR on "L OP .5" for any operator OP
   KOB0044  SYSTEM ERROR if a WS FULL occurs during selective specification
   KOB0098  WS storage lost using strand notation with general arrays

 APL language (display)
   KOA0504  T (T-Delta) on branch to zero shows "[n] 0" with wrong n
   KOB0016  Display of largest possible negative integer, -2147483648

 -------------------------------------------------------------------------------

 External functions (general)
   KOA0495  SYSTEM ERROR if an external function is called which has no result

 ATR external function
   KOB0023  Is not handling the S1 type correctly
   KOB0045  Fails for an empty right argument
   KOB0073  Bad CR (QuadCR) display of a defined function after it calls ATR
   KOB0095  Patterns with unknown lengths not handled properly

 FILE external function
   KOA0502  Can cause SYSTEM ERROR if arguments are not correctly specified
   KOB0050  Can cause SYSTEM ERROR on a sequence of large file reads

 RTA external function
   KOA0497  Not handling the S1 type correctly when used in a nested pattern
   KOB0095  Patterns with unknown lengths not handled properly

 -------------------------------------------------------------------------------

 Shared variables
   KOA0301  SWAPPER.DAT grows with repeated use of auxiliary processors
   KOB0048  One APL2 session can trick the SVP into signing another off

 AP 120
   KOB0026  Displays the wrong event and reason codes in some message windows

 AP 124
   KOB0070  SYS3175 exception

 AP 145
   KOB0031  Does not pass WM_QUIT messages to the application
   KOB0039  Crashes on a character vector assignment to the shared variable
   KOB0074  Rejects large integers
   KOB0078  Some messages are not dispatched
   KOB0080  Typos in the on-line help

 AP 207
   KOB0034  Does not fill correctly when scissor is on
   KOB0083  Printing resolution is poor
   KOB0093  Fontdef with 23 character name may cause the next function to fail
   KOB0094  Exit processing not done properly when the window is closed

 -------------------------------------------------------------------------------

 FILE workspace
   KOB0024  Has an unnecessary read limit of 65400 bytes in some functions

 PMWIN workspace
   KOB0030  Open-object dialog does not list all the variables

 -------------------------------------------------------------------------------

 Session startup
   KOB0092  "-svptrace" parameter values may not be handled properly

 Session manager
   KOA0490  Paste from other products crashes APL2
   KOA0491  Fix typos in Help for F-keys
   KOA0496  Says "input" mode while it is processing stacked data
   KOA0498  Crashes if a line longer than 32k comes from interpreter
   KOB0042  "fields" dialog displays incorrectly on SVGA displays
   KOB0056  Terminates if Print Cancel button is pushed
   KOB0064  Line number in status area is wrong after a find

 Editors
   KOB0003  CHECKWS after resuming execution of a suspended function
   KOB0029  object editor should strip trailing blanks
   KOB0056  APLEDIT terminates if Print Cancel button is pushed

================================================================================
 Support
================================================================================

 We'd like to hear from you!

 Please report any comments, suggestions, or problems through one of the
 following channels:

   Internet:    apl2@vnet.ibm.com

   CompuServe:  go IBMAPL2

   TALKLINK:    OS2bbs1; Qandabbs; TLpgcat

   FAX:         1-408-463-4488

   Phone:       1-408-463-APL2

   Mail:        APL Products & Services
                IBM Santa Teresa Laboratory, M46/D12
                555 Bailey Ave.
                San Jose, CA 95141

================================================================================
 Trademarks
================================================================================

 The following terms are trademarks of the IBM Corporation.  They are
 denoted by an asterisk (*) when they first appear in the text.

     APL2
     IBM
     OS/2

